/*
 * screen definitions for my custom screen 
 *
 */

#define XSIZE 640
#define YSIZE 400

static struct TextAttr TOPAZ80 = {
	(STRPTR)"topaz.font",
	TOPAZ_EIGHTY,0,0
};
static struct NewScreen NewScreenStructure = {
	0,0,	/* screen XY origin relative to View */
	XSIZE,YSIZE+2,	/* screen width and height */
	1,	/* screen depth (number of bitplanes) */
	0,1,	/* detail and block pens */
	LACE+HIRES,	/* display modes for this screen */
	CUSTOMSCREEN,	/* screen type */
	&TOPAZ80,	/* pointer to default screen font */
	(UBYTE *)"PrFont",	/* screen title */
	NULL,	/* first in list of custom screen gadgets */
	NULL	/* pointer to custom BitMap structure */
};

#define NEWSCREENSTRUCTURE NewScreenStructure

static USHORT Palette[] = {
	0x0000, /* color #0 */
	0x0FFF, /* color #1 */
#define PaletteColorCount 2
};

#define PALETTE Palette

/*
 * definition of the main window
 */

static struct NewWindow	New_Window = {
	0, 2,			/* Take all except the */
	XSIZE, YSIZE,	/* top two lines       */
	-1, -1,			/* Default pens */
	CLOSEWINDOW  |MOUSEBUTTONS,	/* Inputs acceppeted */
	WINDOWCLOSE		/* Window Attributes */
	| WINDOWDEPTH | SMART_REFRESH | BORDERLESS ,
	NULL,			/* no gadgets */
	(struct Image *) NULL,
	(UBYTE *) NULL,             /* no title */
	(struct Screen *) NULL,		/* filled at startup */
	(struct BitMap *) NULL,
	0, 0, 0, 0,		/* no change sizes, doesn't matter */
	CUSTOMSCREEN
	} ;



/*
 * Text for requesters 
 */

char msgfilename[80];


struct IntuiText libfailmsg2 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	14,20,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *) msgfilename,	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct IntuiText libfailmsg = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	14,10,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Library Open Failed:",	/* pointer to text */
	&libfailmsg2	/* next IntuiText structure */
};


struct IntuiText openfomsg2 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	14,26,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *) msgfilename,
	NULL	/* next IntuiText structure */
};

struct IntuiText openfomsg = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	14,16,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Can't open font:",	/* pointer to text */
	&openfomsg2	/* next IntuiText structure */
};

struct IntuiText cantxt = {
	2,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	5,3,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"CANCEL",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct IntuiText retrytxt = {
	2,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	5,3,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"RETRY",	/* pointer to text */
	NULL	/* next IntuiText structure */
};


struct IntuiText oktxt = {
	2,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	5,3,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"OK",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct IntuiText prfailtxt = {
	2,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	14,16,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Printer failed to open",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct IntuiText memmsg = {
	2,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	14,16,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Not Enough Memory",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct IntuiText availmsg = {
	2,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	14,16,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"No Fonts Available",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct IntuiText screenfail = {
	2,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	14,16,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"PrFont:Can't Open Screen",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct IntuiText windfail = {
	2,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	14,16,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"PrFont:Can't Open Window",	/* pointer to text */
	NULL	/* next IntuiText structure */
};
